# std::uses_allocator<std::tuple>

From cppreference.com
< cpp‎ | utility‎ | tuple

Defined in header `<tuple>` |  |
template< class... Types, class Alloc > struct uses_allocator< std::tuple<Types...>, Alloc > : std::true_type { }; |  | (since C++11)

This specialization of std::uses_allocator informs other library components that tuples support uses-allocator construction, even though they do not have a nested `allocator_type`.

## Inherited from std::integral_constant

### Member constants

value [static] | true (public static member constant)

### Member functions

operator bool | converts the object to bool, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `bool`
`type` | std::integral_constant<bool, value>

### Example

Run this code

    // myalloc is a stateful Allocator with a single-argument constructor
    // that takes an int. It has no default constructor.

        typedef std::vector<int, myalloc<int>> innervector_t;
        typedef std::tuple<int, innervector_t> elem_t;
        typedef std::scoped_allocator_adaptor< myalloc<elem_t>, myalloc<int>> Alloc;
        Alloc a(1,2);
        std::vector<elem_t, Alloc> v(a);
        v.resize(1);                  // uses allocator #1 for elements of v
        std::get<1>(v[0]).resize(10); // uses allocator #2 for innervector_t

### See also

uses_allocator (C++11) | checks if the specified type supports uses-allocator construction (class template)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/utility/tuple/uses_allocator&oldid=63128"